/**
 * NOTE: This class is auto generated by the swagger code generator program (2.4.21).
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */
package mx.sidlors.dvd.rental.api;

import  mx.sidlors.dvd.rental.model.Film;
import io.swagger.annotations.*;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RequestPart;
import org.springframework.web.multipart.MultipartFile;

import javax.validation.Valid;
import javax.validation.constraints.*;
import java.util.List;
@javax.annotation.Generated(value = "io.swagger.codegen.languages.SpringCodegen", date = "2021-07-21T02:33:33.560Z")

@Validated
@Api(value = "film", description = "the film API")
@RequestMapping(value = "")
public interface FilmApi {

    @ApiOperation(value = "", nickname = "filmDelete", notes = "", tags={ "film", })
    @ApiResponses(value = { 
        @ApiResponse(code = 204, message = "No Content") })
    @RequestMapping(value = "/film",
        produces = { "application/json", "application/vnd.pgrst.object+json", "text/csv" }, 
        consumes = { "application/json", "application/vnd.pgrst.object+json", "text/csv" },
        method = RequestMethod.DELETE)
    ResponseEntity<Void> filmDelete(@ApiParam(value = "") @Valid @RequestParam(value = "film_id", required = false) String filmId,@ApiParam(value = "") @Valid @RequestParam(value = "title", required = false) String title,@ApiParam(value = "") @Valid @RequestParam(value = "description", required = false) String description,@ApiParam(value = "") @Valid @RequestParam(value = "release_year", required = false) String releaseYear,@ApiParam(value = "") @Valid @RequestParam(value = "language_id", required = false) String languageId,@ApiParam(value = "") @Valid @RequestParam(value = "rental_duration", required = false) String rentalDuration,@ApiParam(value = "") @Valid @RequestParam(value = "rental_rate", required = false) String rentalRate,@ApiParam(value = "") @Valid @RequestParam(value = "length", required = false) String length,@ApiParam(value = "") @Valid @RequestParam(value = "replacement_cost", required = false) String replacementCost,@ApiParam(value = "") @Valid @RequestParam(value = "rating", required = false) String rating,@ApiParam(value = "") @Valid @RequestParam(value = "last_update", required = false) String lastUpdate,@ApiParam(value = "") @Valid @RequestParam(value = "special_features", required = false) String specialFeatures,@ApiParam(value = "") @Valid @RequestParam(value = "fulltext", required = false) String fulltext,@ApiParam(value = "Preference" , allowableValues="return=representation, return=minimal, return=none") @RequestHeader(value="Prefer", required=false) String prefer);


    @ApiOperation(value = "", nickname = "filmGet", notes = "", response = Film.class, responseContainer = "List", tags={ "film", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "OK", response = Film.class, responseContainer = "List"),
        @ApiResponse(code = 206, message = "Partial Content") })
    @RequestMapping(value = "/film",
        produces = { "application/json", "application/vnd.pgrst.object+json", "text/csv" }, 
        consumes = { "application/json", "application/vnd.pgrst.object+json", "text/csv" },
        method = RequestMethod.GET)
    ResponseEntity<List<Film>> filmGet(@ApiParam(value = "") @Valid @RequestParam(value = "film_id", required = false) String filmId,@ApiParam(value = "") @Valid @RequestParam(value = "title", required = false) String title,@ApiParam(value = "") @Valid @RequestParam(value = "description", required = false) String description,@ApiParam(value = "") @Valid @RequestParam(value = "release_year", required = false) String releaseYear,@ApiParam(value = "") @Valid @RequestParam(value = "language_id", required = false) String languageId,@ApiParam(value = "") @Valid @RequestParam(value = "rental_duration", required = false) String rentalDuration,@ApiParam(value = "") @Valid @RequestParam(value = "rental_rate", required = false) String rentalRate,@ApiParam(value = "") @Valid @RequestParam(value = "length", required = false) String length,@ApiParam(value = "") @Valid @RequestParam(value = "replacement_cost", required = false) String replacementCost,@ApiParam(value = "") @Valid @RequestParam(value = "rating", required = false) String rating,@ApiParam(value = "") @Valid @RequestParam(value = "last_update", required = false) String lastUpdate,@ApiParam(value = "") @Valid @RequestParam(value = "special_features", required = false) String specialFeatures,@ApiParam(value = "") @Valid @RequestParam(value = "fulltext", required = false) String fulltext,@ApiParam(value = "Filtering Columns") @Valid @RequestParam(value = "select", required = false) String select,@ApiParam(value = "Ordering") @Valid @RequestParam(value = "order", required = false) String order,@ApiParam(value = "Limiting and Pagination" ) @RequestHeader(value="Range", required=false) String range,@ApiParam(value = "Limiting and Pagination" , defaultValue="items") @RequestHeader(value="Range-Unit", required=false) String rangeUnit,@ApiParam(value = "Limiting and Pagination") @Valid @RequestParam(value = "offset", required = false) String offset,@ApiParam(value = "Limiting and Pagination") @Valid @RequestParam(value = "limit", required = false) String limit,@ApiParam(value = "Preference" , allowableValues="count=none") @RequestHeader(value="Prefer", required=false) String prefer);


    @ApiOperation(value = "", nickname = "filmPatch", notes = "", tags={ "film", })
    @ApiResponses(value = { 
        @ApiResponse(code = 204, message = "No Content") })
    @RequestMapping(value = "/film",
        produces = { "application/json", "application/vnd.pgrst.object+json", "text/csv" }, 
        consumes = { "application/json", "application/vnd.pgrst.object+json", "text/csv" },
        method = RequestMethod.PATCH)
    ResponseEntity<Void> filmPatch(@ApiParam(value = "") @Valid @RequestParam(value = "film_id", required = false) String filmId,@ApiParam(value = "") @Valid @RequestParam(value = "title", required = false) String title,@ApiParam(value = "") @Valid @RequestParam(value = "description", required = false) String description,@ApiParam(value = "") @Valid @RequestParam(value = "release_year", required = false) String releaseYear,@ApiParam(value = "") @Valid @RequestParam(value = "language_id", required = false) String languageId,@ApiParam(value = "") @Valid @RequestParam(value = "rental_duration", required = false) String rentalDuration,@ApiParam(value = "") @Valid @RequestParam(value = "rental_rate", required = false) String rentalRate,@ApiParam(value = "") @Valid @RequestParam(value = "length", required = false) String length,@ApiParam(value = "") @Valid @RequestParam(value = "replacement_cost", required = false) String replacementCost,@ApiParam(value = "") @Valid @RequestParam(value = "rating", required = false) String rating,@ApiParam(value = "") @Valid @RequestParam(value = "last_update", required = false) String lastUpdate,@ApiParam(value = "") @Valid @RequestParam(value = "special_features", required = false) String specialFeatures,@ApiParam(value = "") @Valid @RequestParam(value = "fulltext", required = false) String fulltext,@ApiParam(value = "film"  )  @Valid @RequestBody Film film,@ApiParam(value = "Preference" , allowableValues="return=representation, return=minimal, return=none") @RequestHeader(value="Prefer", required=false) String prefer);


    @ApiOperation(value = "", nickname = "filmPost", notes = "", tags={ "film", })
    @ApiResponses(value = { 
        @ApiResponse(code = 201, message = "Created") })
    @RequestMapping(value = "/film",
        produces = { "application/json", "application/vnd.pgrst.object+json", "text/csv" }, 
        consumes = { "application/json", "application/vnd.pgrst.object+json", "text/csv" },
        method = RequestMethod.POST)
    ResponseEntity<Void> filmPost(@ApiParam(value = "film"  )  @Valid @RequestBody Film film,@ApiParam(value = "Filtering Columns") @Valid @RequestParam(value = "select", required = false) String select,@ApiParam(value = "Preference" , allowableValues="return=representation, return=minimal, return=none") @RequestHeader(value="Prefer", required=false) String prefer);

}
